(function() /** {$b5167ccadfb66ea3ba95d92d7c9946c9} */{
        WeReadBridge = function() /** {$b9c7abd4d524a31563f1f27b768c47a9} */ {
                this._sendMessageQueue = [];
                this._callback_count = 1000;
                this._callback_map = {};
                this.available_func = {};
                this._iframe = document.createElement("iframe");
                this._iframe.setAttribute("id", "iframe");
                this._iframe.setAttribute("style","position:absolute;top:0;left:0;width:1px;height:1px;visibility:hidden;");
                this._QUEUE_HAS_MESSAGE_URL = 'wereadapijs://dispatch_message/';
                document.body.appendChild(this._iframe);

                this._resultIframe = document.createElement("iframe");
                this._resultIframe.setAttribute("id", "_resultIframe");
                this._resultIframe.setAttribute("style","position:absolute;top:0;left:0;width:1px;height:1px;visibility:hidden;");
                this._resultIframe._SET_RESULT_URL = 'wereadapijs://private/setresult/';
                document.body.appendChild(this._resultIframe);
        }

        /**
         * @url qqmail://ftn?a=b&c=d 或则 http://   @return successOrNot
         */
        WeReadBridge.prototype.goToUrl = function(url, successCallback, failCallback) /** {$0a68acb47ae00b9d2a5fed61a8af655d} */ {
        var self = this;
                var params = {"url":url};
                this._call("goToUrl",params,function(successOrNot, result) /** {$73c8dd5b50e13e21a37e76c5c2eead04} */{
                        var params = {"goToUrl":successOrNot};
                        self.localLog(params);
                        if (successOrNot) {
                           successCallback();
                        } else {
                           failCallback(result);
                        }
                });
   }

        WeReadBridge.prototype.localLog = function(params, successCallback, failCallback) /** {$9fd8e7ec1ddd8fc4d78ce18f0e1677e5} */ {
                var self = this;
                this._call("localLog",params);
        }

        WeReadBridge.prototype.fetchQueue = function() /** {$4a202e1afc4b36610e87f574e5478e15} */ {
                var messageQueueString = JSON.stringify(this._sendMessageQueue);
                this._sendMessageQueue = [];
                this._setResultValue('fetchqueue', messageQueueString);
                return messageQueueString;
        }


    WeReadBridge.prototype._setResultValue = function(scene, result) /** {$23e4b67694084da787d5fa5c739b9a66} */ {
                // Android 通过另外一个iframe上传数据
                if (result === undefined) {
                        result = '';
                }
                this._resultIframe.src = this._resultIframe._SET_RESULT_URL + scene + '&' + this._base64Encode(this._utf8Encode(result));
        }
         // public method for url encoding
        WeReadBridge.prototype._utf8Encode = function(str) /** {$9da9355c0a506c2d0c6dd40c35ea7fb6} */ {
                str = str.replace(/\r\n/g, "\n");
                        var utftext = "";

                        for (var n = 0; n < str.length; n++) {

                                var c = str.charCodeAt(n);

                                if (c < 128) {
                                        utftext += String.fromCharCode(c);
                                } else if ((c > 127) && (c < 2048)) {
                                        utftext += String.fromCharCode((c >> 6) | 192);
                                        utftext += String.fromCharCode((c & 63) | 128);
                                } else {
                                        utftext += String.fromCharCode((c >> 12) | 224);
                                        utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                                        utftext += String.fromCharCode((c & 63) | 128);
                                }

                        }

                        return utftext;
        }

        WeReadBridge.prototype._base64Encode = function(str) /** {$caa95e8456b5cda1716514776a0bf77a} */ {
                //base64编码
                var base64encodechars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
                if (str === undefined) {
                        return str;
                }
                var out, i, len;
                var c1, c2, c3;
                len = str.length;
                i = 0;
                out = "";
                while (i < len) {
                        c1 = str.charCodeAt(i++) & 0xff;
                        if (i == len) {
                                out += base64encodechars.charAt(c1 >> 2);
                                out += base64encodechars.charAt((c1 & 0x3) << 4);
                                out += "==";
                break;
                        }
                        c2 = str.charCodeAt(i++);
                        if (i == len) {
                                out += base64encodechars.charAt(c1 >> 2);
                                out += base64encodechars.charAt(((c1 & 0x3) << 4) | ((c2 & 0xf0) >> 4));
                                out += base64encodechars.charAt((c2 & 0xf) << 2);
                                out += "=";
                                break;
                        }
                        c3 = str.charCodeAt(i++);
                        out += base64encodechars.charAt(c1 >> 2);
                        out += base64encodechars.charAt(((c1 & 0x3) << 4) | ((c2 & 0xf0) >> 4));
                        out += base64encodechars.charAt(((c2 & 0xf) << 2) | ((c3 & 0xc0) >> 6));
                        out += base64encodechars.charAt(c3 & 0x3f);
                }
                return out;
        }



        WeReadBridge.prototype._sendMessage = function(message) /** {$0685a6a5b33dbf2f615a5ae1faedb0c8} */ {
        this._sendMessageQueue.push(message);
                this._iframe.src = this._QUEUE_HAS_MESSAGE_URL;
        }

        WeReadBridge.prototype.handleMessage = function(message) /** {$623f3ca7480b38b659e4f32c858046f4} */ {
                var callbackId = message["callbackId"];
                if (!callbackId || typeof callbackId !== 'string') {
                        return;
                }
                var successOrNot = message["successOrNot"];
                var params = message["params"];
                if (typeof this._callback_map[callbackId] === "function"){
                        this._callback_map[callbackId](successOrNot,params);
                        delete this._callback_map[callbackId];
                }
        }

        WeReadBridge.prototype._call = function(func, params, callback) /** {$0a78d8c17b87d24c599c91b498b8662b} */ {
        if (!func || typeof func !== "string") {
                        return;
                }

                if (typeof params !== "object") {
                        params = {};
                }

                var msgObj = {"func":func,"params":params};

                var callbackID = (this._callback_count++).toString();

                if (typeof callback === "function") {
                        this._callback_map[callbackID] = callback;
                        msgObj["callbackId"] = callbackID;
                }
                this._sendMessage(JSON.stringify(msgObj));
        }
})();
 window.WeReadBridge = new WeReadBridge();
/*
 * window.WeReadBridge.goToUrl("http://wecall.qq.com/");//weread://bookDetail?opentype=0&bookId=414048");
        load页面之前需要先执行以下的js
        eval('window["__QMB_INFO__"]={apis:{"a":1,"b":1},ver:"4.0.5",os:"android"};window["__QMB_INFO_CALL__"]&&window["__QMB_INFO_CALL__"]();');
*/

// window.WeReadBridge.moreOperation(new Array({'shareToWechatTimeLine': {'title':'title','imageUrl':'imageUrl','abstract':'abstract','url':'url'}}));
// window.WeReadBridge.dismissController();
// window.WeReadBridge.shareToWechatFriend({'title':'中文','imageUrl':'imageUrl','abstract':'中文测试','url':'url'});